      subroutine emis_scat_index(nwork, Tc, T_bkgrd, 
     &   bkgrd_clear_option, T_bkgrd_clear, pixel_status, sfctype,
     &   emisIndex, scatIndex)

      implicit none
      include 'parameters.inc'
      
      integer     nwork
      logical     app_sfc
      real        Tc(NPIX, MAX_SCANS, NCHAN)
      real        T_bkgrd(NPIX, MAX_SCANS, NCHAN)
      integer     bkgrd_clear_option
      real        T_bkgrd_clear(NPIX, MAX_SCANS, NCHAN)
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*2   pixel_status(NPIX, MAX_SCANS)
      real        emisIndex(NPIX, MAX_SCANS, NEMIS)
      real        scatIndex(NPIX, MAX_SCANS, NSCAT)
      real        E19maxPol, E37maxPol, E85maxPol
      real        T37vbk, T85vbk, T85hbk
      real        T19hbk, T19vbk, T23vbk
      real        T37hbk
      integer     lin, pix, nch

      real *4     a
      real *4     b

      real        T85bkmean, a_ns, b_ns
      real        T85mean, T85mean_ns, T85mean_s, f_ns

      real        T0
      data        T0/273.0/

      a=-0.192
      b=52.4

      if(bkgrd_clear_option .eq. 2) then

c     Clear background polarizations/radiances
  
      E19maxPol = 0.
      E37maxPol = 0.
      E85maxPol = 0.
      do lin = 1, nwork
         do pix = 1, NPIX
       
            if (pixel_status(pix,lin) .lt. 0) goto 10

            ! Identify applicable surfaces.
            app_sfc = .FALSE.
            if (sfctype(pix,lin) .EQ. 0) app_sfc = .TRUE.

            ! proceed only with applicable surfaces
            if ( .not. app_sfc ) goto 10

            ! get max pol.
            if((T_bkgrd(pix,lin,2) - T_bkgrd(pix,lin,1)) .gt. 
     &         E19maxPol)then
               E19maxPol = T_bkgrd(pix,lin,2) - T_bkgrd(pix,lin,1)
               E37maxPol = T_bkgrd(pix,lin,5) - T_bkgrd(pix,lin,4)
               E85maxPol = T_bkgrd(pix,lin,7) - T_bkgrd(pix,lin,6)
                 T19hbk = T_bkgrd(pix,lin,1)
                 T19vbk = T_bkgrd(pix,lin,2)
                 T23vbk = T_bkgrd(pix,lin,3)
                 T37hbk = T_bkgrd(pix,lin,4)
                 T37vbk = T_bkgrd(pix,lin,5)
                 T85hbk = T_bkgrd(pix,lin,6)
                 T85vbk = T_bkgrd(pix,lin,7)
            endif
            
10          continue   
            
         end do
      end do
      end if

c     Emission and scattering indices
      do lin = 1, nwork
         do pix = 1, NPIX
               
             if (pixel_status(pix,lin) .lt. 0) go to 30
            
            ! Identify applicable surfaces.
            app_sfc = .FALSE.
            if (sfctype(pix,lin) .EQ. 0) app_sfc = .TRUE. 
            
            ! proceed only with applicable surfaces
            if ( .not. app_sfc ) goto 30
            
            ! compute indices
            if(bkgrd_clear_option .eq. 2) then
              T_bkgrd_clear(pix,lin,1)=T19hbk
              T_bkgrd_clear(pix,lin,2)=T19vbk
              T_bkgrd_clear(pix,lin,3)=T23vbk
              T_bkgrd_clear(pix,lin,4)=T37hbk
              T_bkgrd_clear(pix,lin,5)=T37vbk
              T_bkgrd_clear(pix,lin,6)=T85hbk
              T_bkgrd_clear(pix,lin,7)=T85vbk
            else  
              E19maxPol = T_bkgrd_clear(pix,lin,2) - 
     &         T_bkgrd_clear(pix,lin,1)
              E37maxPol = T_bkgrd_clear(pix,lin,5) - 
     &         T_bkgrd_clear(pix,lin,4)
              E85maxPol = T_bkgrd_clear(pix,lin,7) - 
     &         T_bkgrd_clear(pix,lin,6)
              T37vbk = T_bkgrd_clear(pix,lin,5)
              T85hbk = T_bkgrd_clear(pix,lin,6)
              T85vbk = T_bkgrd_clear(pix,lin,7)
            end if
c     Parameters for emisIndex85 correction for polarized scatter
            T85bkmean = (T85vbk + T85hbk)/2.
            if(abs(T85bkmean-273.) .gt. 0.1) then
              a_ns = E85maxPol/(T85bkmean-273.)
              b_ns = -273.*a_ns
            else
              a_ns = -999.
              b_ns = -999.
            end if

            emisIndex(pix,lin,1) = (Tc(pix,lin,2) - Tc(pix,lin,1)) / 
     &                   E19maxPol
            emisIndex(pix,lin,2) = (Tc(pix,lin,5) - Tc(pix,lin,4)) / 
     &                   E37maxPol
c           correction for polarization due to scattering at 85 GHz
            T85mean = (Tc(pix,lin,7) + Tc(pix,lin,6))/2.
            T85bkmean = (T85vbk + T85hbk)/2.
            if(abs(T85bkmean-273.) .gt. 0.1) then
              a_ns = E85maxPol/(T85bkmean-273.)
              b_ns = -273.*a_ns
              T85mean_ns = (Tc(pix,lin,7) - Tc(pix,lin,6)
     &         - b_ns)/a_ns
            else
              T85mean_ns=273.
            end if

            T85mean_s = (Tc(pix,lin,7) - Tc(pix,lin,6) - b)/a
            if(abs(T85mean_ns-T85mean_s) .gt. 0.1) then
              f_ns = (T85mean - T85mean_s)/(T85mean_ns - T85mean_s)
            else
              f_ns = 1.
            end if

            if(f_ns .lt. 0.) f_ns = 0.
            if(f_ns .gt. 1.) f_ns = 1.
            emisIndex(pix,lin,3) = (Tc(pix,lin,7) - Tc(pix,lin,6)) / 
     &                   E85maxPol
            emisIndex(pix,lin,3) = f_ns * emisIndex(pix,lin,3)
            scatIndex(pix,lin,1) = 
     &                   emisIndex(pix,lin,2) * T37vbk +
     &                   (1-emisIndex(pix,lin,2))*T0 - Tc(pix,lin,5)
            scatIndex(pix,lin,2) = 
     &                   emisIndex(pix,lin,3) * T85vbk +
     &                   (1-emisIndex(pix,lin,3))*T0 - Tc(pix,lin,7)

30          continue      
         end do
      end do 
      return
      end
