      ! Hiro  (12/09/02)
      ! Interpolation of freezing height
      Subroutine int_frzhgt(nwork, frz_c, frz_w, frzheight_int)
      Implicit NONE

      Include 'parameters.inc'

      ! Input
      integer     nwork
      real        frz_w(NPIX, MAX_SCANS)
      real        frz_c(NPIX, MAX_SCANS)
      ! Output
      real        frzheight_int(NPIX, MAX_SCANS)
      ! Local
      integer     nadjcnt_pix, nadjcnt_lin
      integer     nthresh
      integer     lin, pix
      integer     dlin, dpix
      integer     lsub_bgn, lsub_end
      integer     psub_bgn, psub_end
      integer     lsub, psub
      integer     ipix
      real        sum_frz_w

      ! adjacent nadjcnt_pix * nadjcnt_lin pixels are used for
      ! interpolating freezing height. Both nadjcnt_pix and nadjcnt_lin
      ! should be odd numbers. Interpolation is performed only if the
      ! number of pixels on which frz_w is assigned exceeds nthresh.

      Parameter( nadjcnt_pix = 11)
      Parameter( nadjcnt_lin =  7)
      Parameter( nthresh     = 10)

      dlin = (nadjcnt_lin - 1) / 2
      dpix = (nadjcnt_pix - 1) / 2
      do lin = 1 , nwork
         do pix = 1 , NPIX

            if (frz_w(pix, lin).gt.0.) then
               frzheight_int(pix, lin) = frz_w(pix, lin)
            else
               frzheight_int(pix, lin) = frz_c(pix, lin)
            endif

            lsub_bgn = max(1,     lin-dlin)
            psub_bgn = max(1,     pix-dpix)
            lsub_end = min(nwork, lin+dlin)
            psub_end = min(NPIX , pix+dpix)

            sum_frz_w = 0.
            ipix      = 0
            do lsub = lsub_bgn, lsub_end
               do psub = psub_bgn, psub_end
                  if (frz_w(psub,lsub).gt.0.) then
                     ipix = ipix + 1
                     sum_frz_w = sum_frz_w + frz_w(psub,lsub)
                  endif
               end do
            end do

            if (ipix.ge.nthresh) then
               frzheight_int(pix, lin) = sum_frz_w / ipix
            endif
         end do
      end do

      return
      end
