      ! Changed for TMI	9/1997
      ! if ( rms2_min .ge. 1000. ) goto 10 ==>
      ! if ( rms2_min .ge. 10000. ) goto 10            6/1998
      ! Eric Nelkin/SSAI 11/ 7/2003  TRMM Version 6-equivalent, obtained
      !                              from Jeff McCollum; this is SSM/I
      !                              V7 for land, but whole (land/ocean/
      !                              coast) package is called "V6.5S".
      ! Eric Nelkin/SSAI  2/10/2004  Assign quality = 12.0 for ambiguous
      !                              pixels with negated sfcrain, so
      !                              they will be retained in rain-ctrl
      ! Eric Nelkin/SSAI 11/ 3/2011  Move pixel_status "goto 10" check
      !                              after app_sfc assignment; avoids
      !                              check on uninitialized app_sfc

      !  Routine calculates rainfall from a database and does more
      !  smoothing than TRMM Version 5.

      subroutine rain_land(nwork, Tc, sfctype,
     &	 	  pixel_status, rain_status, dbl_nprofiles,
     &	 	  dbl_sfc_code, dbl_occur,dbl_sfcrain,
     &	 	  dbl_convect, dbl_clw, dbl_rain, dbl_ciw,
     &	 	  dbl_ice, dbl_Q1, dbl_Tb,
     &	 	  sfcrain, convect, quality,
     &	 	  structure, clw, rain, ciw, ice, Q1, dbl_cstype)
      implicit none
      include 'parameters.inc'

      integer     nwork
      logical     structure
      real        Tc(NPIX, MAX_SCANS, NCHAN)
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)
      integer     dbl_nprofiles(DB_LAND)
      integer     dbl_sfc_code(DB_LAND)
      integer     dbl_cstype(DB_LAND,DBL_MXPROFILE)
      integer*2   dbl_occur(DB_LAND,DBL_MXPROFILE)
      real        dbl_sfcrain(DB_LAND,DBL_MXPROFILE)
      real        dbl_convect(DB_LAND,DBL_MXPROFILE)
      real        dbl_clw(DB_LAND,DBL_MXPROFILE,NLYR)
      real        dbl_rain(DB_LAND,DBL_MXPROFILE,NLYR)
      real        dbl_ciw(DB_LAND,DBL_MXPROFILE,NLYR)
      real        dbl_ice(DB_LAND,DBL_MXPROFILE,NLYR)
      real        dbl_Q1(DB_LAND,DBL_MXPROFILE,NLYR)
      real        dbl_Tb(DB_LAND,DBL_MXPROFILE,DB_NCHAN)
      real        sfcrain(NPIX, MAX_SCANS)
      real        convect(NPIX, MAX_SCANS)
      real        quality(NPIX, MAX_SCANS)
      real        clw(NPIX, MAX_SCANS,NLYR)
      real        rain(NPIX, MAX_SCANS,NLYR)
      real        ciw(NPIX, MAX_SCANS,NLYR)
      real        ice(NPIX, MAX_SCANS,NLYR)
      real        Q1(NPIX, MAX_SCANS,NLYR)
      real        clwcs(NCSTYPE,NLYR)
      real        raincs(NCSTYPE,NLYR)
      real        ciwcs(NCSTYPE,NLYR)
      real        icecs(NCSTYPE,NLYR)
      real        Q1cs(NCSTYPE,NLYR)

      integer     lin, pix, lyr
      integer     id, prof, csid, i, j, index1, index2
      integer     prindex1(NCSTYPE), prindex2(NCSTYPE), div
      logical     app_sfc
      real        sigma, sigma2
      real        wgt_limit, wgt_coef
      real        sumwgt(NCSTYPE), sumrms(NCSTYPE),
     &            sumsfcrain(NCSTYPE)
      real        sumclw(NCSTYPE,NLYR), sumrain(NCSTYPE,NLYR)
      real        sumciw(NCSTYPE,NLYR), sumice(NCSTYPE,NLYR),
     &            sumQ1(NCSTYPE,NLYR)
      real        d1, d2, d3, d4, d5, d6, d7, d8, d9
      real        rms2, rms2_min(NCSTYPE), weight, wgt_profile
      real        sm1,smprof1,sdc,sdc2
      real        p85

      real        sfcraincs(NCSTYPE),csi,csis,csic,csim
      real        qualitycs(NCSTYPE)
c
c     Assign gaussian shape/cutoff constants
c
      sigma       =  6.
      wgt_limit   = 0.001
      sigma2 = sigma*sigma
      wgt_coef = 0.797884561/sigma
c
      do lin = 1, nwork
         do pix = 1, NPIX

CC          if (pixel_status(pix,lin) .lt. 0) goto 10

            ! Identify applicable surfaces.

            app_sfc = .FALSE.
            if (sfctype(pix,lin) .EQ. 1) app_sfc = .TRUE.

            ! proceed only with applicable surfaces
            if ( .not. app_sfc .or. pixel_status(pix,lin) .lt. 0) then
c
c Don't process this pixel any longer
c
               goto 10
            endif

            ! Assign zero rainfall rate and high quality to
            ! pixels which have been previously screened.
            ! or that don't meet the minimum tv22-th85

            sm1=Tc(pix,lin,3)-Tc(pix,lin,7)
c
c Try to get more rain area
c
            if(sm1.lt.8.or.Tc(pix,lin,6).gt.280.) then
               rain_status(pix,lin)=-61
            endif

            sm1=Tc(pix,lin,7)
c
c             Skip retrieval loop if Tbs are too warm.  This step
c             is applicable because only scattering signature is
c             currently being used.
c
            if (rain_status(pix,lin).lt.0) then
               sfcrain(pix,lin) = 0.
               convect(pix,lin) = 0.
               quality(pix,lin) = 0.
               if ( structure ) then
                  do lyr = 1, NLYR
                     clw(pix,lin,lyr)  = 0.
                     rain(pix,lin,lyr) = 0.
                     ciw(pix,lin,lyr)  = 0.
                     ice(pix,lin,lyr)  = 0.
                     Q1(pix,lin,lyr)   = 0.
                  end do
               endif
               goto 10
            endif

               ! Initialize internal sums
               do csid = 1, NCSTYPE
                  sumwgt(csid)     = 0.
                  sumrms(csid)     = 0.
                  sumsfcrain(csid) = 0.
                  if ( structure ) then
                     do lyr = 1, NLYR
                        sumclw(csid,lyr)  = 0.
                        sumrain(csid,lyr) = 0.
                        sumciw(csid,lyr)  = 0.
                        sumice(csid,lyr)  = 0.
                        sumQ1(csid,lyr)   = 0.
                     end do
                  endif
                  rms2_min(csid)  = 10000.

               enddo

              ! Loop over the profiles in each of the databases
               do id = 1, DB_LAND

                  ! check that database surface is land
                  if (dbl_sfc_code(id) .ne. 1 ) goto 20

                  do prof = 1, dbl_nprofiles(id)

                     csid = dbl_cstype(id,prof)
                     smprof1=dbl_Tb(id,prof,7)
c                     smprof1=dbl_Tb(id,prof,3)-dbl_Tb(id,prof,7)
		     rms2=(sm1-smprof1)*(sm1-smprof1)/3.5

                     ! keep track of smallest rms
                     if ( rms2 .lt. rms2_min(csid) ) then
                        rms2_min(csid) = rms2
                        prindex1(csid) = id
                        prindex2(csid) = prof
                     endif

                     ! Compute weight assigned to structure
                     weight = wgt_coef*exp(-rms2/(2.*sigma2))

                     if ( weight .ge. wgt_limit ) then

                        wgt_profile = dbl_occur(id,prof)*weight
                        sumwgt(csid) = sumwgt(csid) + wgt_profile
                        sumrms(csid) = sumrms(csid) +
     &                       wgt_profile*sqrt(rms2)
                        sumsfcrain(csid) = sumsfcrain(csid) +
     &                       wgt_profile*dbl_sfcrain(id, prof)
                        if ( structure ) then
                           do lyr = 1, NLYR
                              sumclw(csid,lyr)  = sumclw(csid,lyr) +
     &                               wgt_profile*dbl_clw(id,prof,lyr)
                              sumrain(csid,lyr)  = sumrain(csid,lyr) +
     &                               wgt_profile*dbl_rain(id,prof,lyr)
                              sumciw(csid,lyr)  = sumciw(csid,lyr) +
     &                               wgt_profile*dbl_ciw(id,prof,lyr)
                              sumice(csid,lyr)  = sumice(csid,lyr) +
     &                               wgt_profile*dbl_ice(id,prof,lyr)
                              sumQ1(csid,lyr)   = sumQ1(csid,lyr) +
     &                               wgt_profile*dbl_Q1(id,prof,lyr)
                           end do
                        endif
                     endif
                  end do
c
c This is the enddo for the land database searches
c
 20          end do
 
             do csid = 1, NCSTYPE
               ! Normalize output profiles.  If no profiles were
               ! ever examined, rms2_min is not modified and can be
               ! used to skip normalization.

               if ( rms2_min(csid) .ge. 10000. .and. csid.eq.1) goto 10

               if ( sumwgt(csid) .gt. 0. ) then
                  sfcraincs(csid) = sumsfcrain(csid)/sumwgt(csid)
                  qualitycs(csid) = sumrms(csid)/sumwgt(csid)
c
                  if ( structure ) then
                     do lyr = 1, NLYR
                        clwcs(csid,lyr)  =
     &                      sumclw(csid,lyr)/sumwgt(csid)
                        raincs(csid,lyr) =
     &                      sumrain(csid,lyr)/sumwgt(csid)
                        ciwcs(csid,lyr)  =
     &                      sumciw(csid,lyr)/sumwgt(csid)
                        icecs(csid,lyr)  =
     &                      sumice(csid,lyr)/sumwgt(csid)
                        Q1cs(csid,lyr)   =
     &                      sumQ1(csid,lyr)/sumwgt(csid)
                     end do
                  endif
               else
                 sfcraincs(csid) =
     &                  dbl_sfcrain(prindex1(csid),prindex2(csid))
                 if ( structure ) then
                     do lyr = 1, NLYR
                        clwcs(csid,lyr)   =
     &                     dbl_clw(prindex1(csid),prindex2(csid),lyr)
                        raincs(csid,lyr)  =
     &                     dbl_rain(prindex1(csid),prindex2(csid),lyr)
                        ciwcs(csid,lyr)   =
     &                     dbl_ciw(prindex1(csid),prindex2(csid),lyr)
                        icecs(csid,lyr)   =
     &                     dbl_ice(prindex1(csid),prindex2(csid),lyr)
                        Q1cs(csid,lyr)    =
     &                     dbl_Q1(prindex1(csid),prindex2(csid),lyr)
                     end do
                 endif
                 goto 15
               endif
c         write(*,*) sfcraincs(csid),csid,pix,lin
             end do
c
c Calculate the predictors of convective probability
c
         sdc=0
         sdc2=0
         div=9
c
         do index2=lin-1,lin+1
            if(index2.lt.1.or.index2.gt.nwork) goto 15
            do index1=pix-1,pix+1
               if(index1.lt.1.or.index1.gt.npix) goto 15
c
               if(Tc(index1,index2,7).gt.0) then
                  sdc=sdc+Tc(index1,index2,7)
                  sdc2=sdc2+Tc(index1,index2,7)**2
                else
                  div=div-1
               endif
            enddo
         enddo

         if(div.gt.4) then
            sdc=(sdc2/div-(sdc/div)**2)**0.5
         else
            goto 15
         endif

c         write(*,*) 'VI:',sdc
c
c Olson et al. 1999 equation
c
 3                p85=(Tc(pix,lin,7)-Tc(pix,lin,6))/12
c
c         E(prob)=P(C)*R(C) + P(S)*R(S) + P(M)*R(M)
c
        csi=p85
c
        csic=0.016+0.022*sdc
c        csic=0.05+0.025*sdc
c        csic=0.15+0.02*sdc
c
c Let's try not making so much stratiform
c
        csis=(0.775-0.023*sdc)
c        csis=0.75-0.03*sdc
c        csis=0.65-0.02*sdc
        csim=1-csic-csis
c        write(*,*) 'fao:',csi
cc      write(*,*) 'sdc,csic,csim,csis',sdc,csic,csim,csis
         if(csi.gt.1.0) csi=1.0
         if(csi.lt.0.0) csi=0.0
c
c One of McCollum's old methods:
c        sfcrain(pix,lin)=(1-csi)*sfcraincs(3)+(csi)*sfcraincs(2)
c 11/7/2003 current method (for SSM/I, TMI, and AMSR):
         sfcrain(pix,lin) = csis*sfcraincs(3) + csic*sfcraincs(2)
     &                    + csim*sfcraincs(1)
c        write(*,*) sfcraincs(3),sfcraincs(2),sfcraincs(1)
c        write(*,*) sfcrain(pix,lin)
c        write(*,*)
c         sfcrain(pix,lin)=csic+csim*0.5
         convect(pix,lin) = (csic)*sfcraincs(2)
         quality(pix,lin) = csis*qualitycs(3) + csic*qualitycs(2)
     &                    + csim*qualitycs(1)
c
c Kept in paper algorithm
         if(Tc(pix,lin,7).lt.189) sfcrain(pix,lin)=sfcraincs(2)
         if ( structure ) then
           do lyr=1,NLYR
             clw(pix,lin,lyr)  = csis*clwcs(3,lyr) + csic*clwcs(2,lyr)
     &           + csim*clwcs(1,lyr)
             rain(pix,lin,lyr) = csis*raincs(3,lyr) + csic*raincs(2,lyr)
     &           + csim*raincs(1,lyr)
             ciw(pix,lin,lyr)  = csis*ciwcs(3,lyr) + csic*ciwcs(2,lyr)
     &           + csim*ciwcs(1,lyr)
             ice(pix,lin,lyr)  = csis*icecs(3,lyr) + csic*icecs(2,lyr)
     &           + csim*icecs(1,lyr)
             Q1(pix,lin,lyr)   = csis*Q1cs(3,lyr) + csic*Q1cs(2,lyr)
     &           + csim*Q1cs(1,lyr)
           end do
         endif
c
         goto 10
c
c Use the default rainfall rate w.out C/S discrimination.
c convect remains undefined and thus missing (-9999.9).  Assign
c quality a poor value of 100.
c
 15      sfcrain(pix,lin)=sfcraincs(1)
         convect(pix,lin) = MISS_FLT
         quality(pix,lin) = 100.
         if (structure) then
            do lyr=1,NLYR
               clw(pix,lin,lyr)  = clwcs(1,lyr)
               rain(pix,lin,lyr) = raincs(1,lyr)
               ciw(pix,lin,lyr)  = ciwcs(1,lyr)
               ice(pix,lin,lyr)  = icecs(1,lyr)
               Q1(pix,lin,lyr)   = Q1cs(1,lyr)
            end do
         endif
c
 10      continue
c
c Set pixel_status to invalid surface type and the surface rainrate
c its negative value for ambiguous rain retrievals.  Assign quality
c a poor value of 12., the maximum allowable threshold for land in
c rain-ctrl.f, to ensure that these pixels are retained when gridded.
c
         if(((rain_status(pix,lin) .eq. 13) .or.
     &      (rain_status(pix,lin) .eq. 14)) .and.
     &      (app_sfc).and.(pixel_status(pix,lin) .ge. 0))then
            pixel_status(pix,lin) = -21
            sfcrain(pix,lin) = -sfcrain(pix,lin)
            if (convect(pix,lin).gt.0.)
     &          convect(pix,lin) = -convect(pix,lin)
            quality(pix,lin) = 12.0
         end if
      end do
      end do

      return
      end
