cejn  subroutine surface_db93_petty (start_line, nfound,  
      subroutine surface_db93_petty (cjobid, nfound,
     &                sfmask2, lat, lon, sfctype, sfckind, do_debug )
      ! Modifications:
      ! Removed NCORE and NBUFF.  Replaced with MAX_SCANS	5/02
      ! Re-written to conform with TRMM V7 standards:
      ! no common blocks, pass in do_debug, save lsinit,lsflag 11/11
      ! Non-PPS version for Bob Joyce                           9/12

      implicit none

      include 'parameters.inc'

*chiu/
C     logical lsinit
C     byte lsflag(2160,1080)
C     save lsflag
C     common/ls/lsflag,lsinit
*chiu/

cejn  integer     start_line, nfound
      integer     nfound
      integer*1   sfmask2(1440,720)
      real        lat(NPIX, MAX_SCANS)
      real        lon(NPIX, MAX_SCANS)
      real        alat, alon  	!chiu
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*1   sfckind(NPIX, MAX_SCANS)
      byte	  igetlandsea  !chiu
      logical     do_debug
      character*256 cjobid

      integer     lin, pix
      integer     ilat, ilon


c     sfmask has the correct values:
c     0 = ocean; 1 = land; 2 = coast; 3 = other

cejn  do lin = start_line, start_line+nfound-1
cejn debug
c       write(*,*) 'In surface-db93-petty, nfound = ', nfound
      do lin = 1, nfound
c       write(*,*) 'lin, nfound = ', lin, nfound
        do pix = 1, NPIX

          alat = lat(pix,lin) 	!chiu
          alon = lon(pix,lin)		!chiu
          ilat = 1 + nint(4.0 * (alat + 89.875))
          if ( alon .ge. 0. ) then
            ilon = 1 + nint(4.0 * (alon - 0.125))
          else
            ilon = 1 + nint(4.0 * (alon + 359.875))
          endif
          if ((ilat .lt. 1) .or. (ilat .gt. 720) .or.
     $       (ilon .lt. 1) .or. (ilon .gt. 1440))  then
            sfctype(pix,lin) = -9	
            sfckind(pix,lin) = -9
          else
*           sfctype(pix,lin) = sfmask1(ilon, ilat)	!chiu
*incorporate land/sea mask of Petty
CC	    sfctype(pix,lin) = igetlandsea(alat,alon)   !chiu
            sfctype(pix,lin) = igetlandsea(alat,alon,cjobid,do_debug)
            sfckind(pix,lin) = sfmask2(ilon, ilat)
          endif
c          write(*,*)sfctype(pix,lin),sfckind(pix,lin),pix,lin
        end do
      end do

      return
      end

************************************************************************
*     This module provides a convenient interface to the 1/6 deg
*     resolution land/sea mask of G. Petty.  Simply call the function
*     igetlandsea(alat,alon).  The returned value will be 0 for water, 1
*     for land, 2 for coast, 3 for permanent ice
*
*     Note the possible need to modify the unit number for reading the
*     data base file (see parameter IU) and/or the path to the data base
*     as set in the parameter DBPATH
*     
*     Version 1.0   6 April 2001  by G.W. Petty (gpetty@aos.wisc.edu)
*
*     Modifications: 
*     Removed NCORE and NBUFF.  Replaced with MAX_SCANS	5/02
*
*      program test
*
* 1    write(*,*)' Enter lat,lon: '
*      read(*,*)alat,alon
*      i = igetlandsea(alat,alon)
*      write(*,*)i
*      goto 1
*      end
*



* Initialize flag indicating whether
* Land/sea mask has been loaded

CC    block data landsea
CC    logical lsinit
CC    byte lsflag(2160,1080) 
CC    common/ls/lsflag,lsinit
CC    data lsinit/.false./
CC    end

* ------------------------------------------
* Load global land/sea mask into memory

      subroutine initlandsea(lsflag,cjobid,do_debug)

      implicit none
CCC
      include 'parameters.inc'		!Chiu

CC    logical lsinit
      logical in_use, do_debug
      integer*4 iunit_s, i, j
      character*256 cjobid
      byte lsflag(2160,1080)
CC    common/ls/lsflag,lsinit

* following value may need to be changed to avoid conflicts in calling program
CC    integer   IU
CC    parameter (IU=21)
CC    character fname*256
CC    integer   i, j      

CC    fname = DBPATH//'igeomask_petty.asc'
CC    open(IU, file = fname,
CC   &     form='formatted',err=999,status='OLD')
CC    read(IU, *, err = 999)((lsflag(i,j),i=1,2160), j=1,1080)
CC    close(IU) 
CC
      in_use = .TRUE.
      iunit_s  = 2
      DO  WHILE ( in_use )
          iunit_s = iunit_s + 1
          INQUIRE ( iunit_s, OPENED=in_use )
      END DO
      OPEN(iunit_s, file = DBPATH//'igeomask_petty.asc',
     &     form='formatted',status='OLD',ERR=43)
      GO TO 44
C
   43 IF (do_debug) WRITE(*,*)
     &   'ERROR: PROBLEM OPENING PETTY SURFACE DATABASE FILE ',
     &   DBPATH//'igeomask_petty.asc',
     &   '; TERMINATING EXECUTION; PROGRAM L3B42MAIN0SS, ',
     &   'SUBROUTINE SURFACE-DB93-PETTY'
      STOP
C
   44 CONTINUE
C
      READ(iunit_s, *, ERR=45) ((lsflag(i,j),i=1,2160), j=1,1080)
      GO TO 46
C
   45 IF (do_debug) WRITE(*,*)
     &   'ERROR: PROBLEM READING PETTY SURFACE DATABASE FILE ',
     &   DBPATH//'igeomask_petty.asc',
     &   '; TERMINATING EXECUTION; PROGRAM L3B42MAIN0SS'
      STOP
   46 CONTINUE
      CLOSE(iunit_s)
      return

C999  continue
CC    write(*,*)'Error opening or reading land/sea file ',fname
CC    stop
      end

* -------------------------------------------------------------
* For a given lat/lon pair, return a value indicating the 
* dominant surface type within a radius of several km.  
*
*     LAND          0  (less than 5% water within ~20 km radius)
*     VEGET         1  (not used)
*     ---           2  (not used)
*     ICE           3
*     POSS_ICE      4
*     WATER         5  (less than 5% land within ~20 km radius)
*     COASTAL WATER 6  (more than 5% land within ~20  km radius)
*     VOID          7  (not used)
*     COASTAL LAND  8  (more than 5% water within ~20 km radius)

CC    byte function igetlandsea(rlat, rlon) 
      byte function igetlandsea(rlat, rlon, cjobid, do_debug)

      implicit none

      real rlat,rlon 

      byte    iflag
      logical lsinit
      save lsinit
      data lsinit /.FALSE./
      byte    lsflag(2160,1080) 
      save lsflag
      logical do_debug
      character*256 cjobid
C     common/ls/lsflag,lsinit

      integer i,j
C     if (.not. lsinit) call initlandsea
      if (.not. lsinit) then
         call initlandsea(lsflag,cjobid,do_debug)
         lsinit = .true.
      endif

      if (rlon .lt. 0.0) rlon = rlon + 360.0 
      if (rlon .ge.  360.0) rlon = rlon - 360.0 
      i = rlon*6.0  + 1
      j = (rlat + 90.0)*6.0 + 1
      iflag =  lsflag(i,j)

* optional:  translate to conventions used in GPROF
* (delete if not wanted)

      if (iflag .eq. 5 .or. iflag .eq. 4) then   ! ocean
         igetlandsea = 0
      else if (iflag .eq. 0) then                ! land
         igetlandsea = 1
      else if (iflag .eq. 6 .or. iflag .eq. 8) then   ! coast
         igetlandsea = 2
      else
         igetlandsea = 3                         ! other
      endif
      return
      end
