      subroutine surface_db93(nwork, sfmask1, sfmask2, lat, lon,
     &                sfctype, sfckind)

      implicit none

      include 'parameters.inc'

      integer     nwork
      integer*1   sfmask1(1440,720)
      integer*1   sfmask2(1440,720)
      real        lat(NPIX, MAX_SCANS)
      real        lon(NPIX, MAX_SCANS)
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*1   sfckind(NPIX, MAX_SCANS)


      integer     lin, pix
      integer     ilat, ilon


c     sfmask has the correct values:
c     0 = ocean; 1 = land; 2 = coast; 3 = other



      do lin = 1, nwork
         do pix = 1, NPIX
            ilat = 1 + nint(4.0 * (lat(pix,lin) + 89.875))
            if ( lon(pix,lin) .ge. 0. ) then
              ilon = 1 + nint(4.0 * (lon(pix,lin) - 0.125))
            else
              ilon = 1 + nint(4.0 * (lon(pix,lin) + 359.875))
            endif
            if ((ilat .lt. 1) .or. (ilat .gt. 720) .or.
     $               (ilon .lt. 1) .or. (ilon .gt. 1440))  then
               sfctype(pix,lin) = -9
               sfckind(pix,lin) = -9
            else
               sfctype(pix,lin) = sfmask1(ilon, ilat)
               sfckind(pix,lin) = sfmask2(ilon, ilat)
            endif
         end do
      end do

      return
      end
