      ! Routine to replace coastal pixels with rain rates less than 2 mm/hr
      ! with 0 mm/hr when none of the 9 pixels centered on the pixel in question       ! have rain rates greater than 2 mm/hr.

      subroutine wvu_ctrl(nwork, pixel_status, 
     &            sfctype, wv, u, lat, lon, bkgrd_status, u_status)


      implicit none           ! Remove at own risk!

C ---------- Variable Declarations ----------

      include 'parameters.inc'

      integer     nwork
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)
      integer*1   sfctype(NPIX, MAX_SCANS)
      real*4      wv(NPIX, MAX_SCANS)
      real*4      u(NPIX, MAX_SCANS)
      integer*2   bkgrd_status(NPIX, MAX_SCANS)
      integer*2   u_status(NPIX, MAX_SCANS)

      real*4      temp_wv(NPIX, MAX_SCANS)
      real*4      temp_u(NPIX, MAX_SCANS)
      integer*2   temp_bkgrd_status(NPIX, MAX_SCANS)
      integer*2   temp_u_status(NPIX, MAX_SCANS)
      real*4      lat(NPIX, MAX_SCANS)
      real*4      lon(NPIX, MAX_SCANS)

      integer     lin, pix
      integer     ip, jp
      integer     ncount
      real*4      sumwv, sumu, sumbs, sumus

      do lin = 1, nwork
         do pix = 1, NPIX
 
            temp_wv(pix,lin) = wv(pix,lin)
            temp_u(pix,lin) = u(pix,lin)
         end do
      end do

      ! Replace coast pixels which do not have a neighbor greater than 2 mm/hr

      do lin = 1, nwork
         do pix = 1, NPIX
c      do lin = 521, 525
c         do pix = 14, 18
           ncount=0
           sumwv=0.0
           sumu=0.0
           sumbs=0
           sumus=0
            if (sfctype(pix,lin) .ne. 0) goto 10
            if ((temp_wv(pix,lin) .eq. 0.0).and.
     &          (pixel_status(pix,lin) .ge. 0)) then
              do ip = lin-7, lin+7
                 do jp = pix-7, pix+7
                    IF((jp.ge.1).and.(jp.le.NPIX).and.
     &                 (ip.ge.1).and.(ip.le.nwork)) THEN
                      if ((sfctype(jp,ip) .eq. 0).and.
     &                   (pixel_status(jp,ip) .ge. 0)) then
c      write(*,*)pix,lin,jp,ip
c      write(*,*)sfctype(jp,ip),temp_wv(jp,ip),pixel_status(jp,ip)
                        IF(temp_wv(jp,ip) .gt. 0.0) THEN
                          ncount=ncount+1
                          sumwv=sumwv+temp_wv(jp,ip)
                          sumu=sumu+temp_u(jp,ip)
                          sumbs=sumbs+temp_bkgrd_status(jp,ip)
                          sumus=sumus+temp_u_status(jp,ip)
c      write(*,*)  lin,pix,lat(jp,ip),lon(jp,ip),wv(jp,ip)
c    &              ,u(jp,ip),ncount,jp,ip
                        ENDIF
                      endif
                    ENDIF
                 end do
              end do
              if(ncount .gt. 0) then
                wv(pix,lin) = sumwv/ncount
                u(pix,lin) = sumu/ncount
                bkgrd_status(pix,lin) = sumbs/ncount
                u_status(pix,lin) = sumus/ncount
              endif
            endif
c      write(10,*)  lin,pix,lat(pix,lin),lon(pix,lin),wv(pix,lin)
c    &              ,u(pix,lin)
c      write(10,*)  bkgrd_status(pix,lin)

c       write(*,*)  lin,pix,lat(pix,lin),lon(pix,lin),wv(pix,lin)
c     &              ,u(pix,lin)
10       end do
      end do
c
      return
      end

